import type { ParsedUrlQuery } from 'querystring';
import type { AppRenderContext, GetDynamicParamFromSegment } from '../../server/app-render/app-render';
import type { LoaderTree } from '../../server/lib/app-dir-module';
import React from 'react';
import type { MetadataContext } from './types/resolvers';
import type { CreateDynamicallyTrackedParams } from '../../server/request/fallback-params';
import type { StaticGenerationStore } from '../../client/components/static-generation-async-storage.external';
export declare function createMetadataContext(pathname: string, renderOpts: AppRenderContext['renderOpts']): MetadataContext;
export declare function createTrackedMetadataContext(pathname: string, renderOpts: AppRenderContext['renderOpts'], staticGenerationStore: StaticGenerationStore | null): MetadataContext;
export declare function createMetadataComponents({ tree, query, metadataContext, getDynamicParamFromSegment, appUsingSizeAdjustment, errorType, createDynamicallyTrackedSearchParams, createDynamicallyTrackedParams, }: {
    tree: LoaderTree;
    query: ParsedUrlQuery;
    metadataContext: MetadataContext;
    getDynamicParamFromSegment: GetDynamicParamFromSegment;
    appUsingSizeAdjustment: boolean;
    errorType?: 'not-found' | 'redirect';
    createDynamicallyTrackedParams: CreateDynamicallyTrackedParams;
    createDynamicallyTrackedSearchParams: (searchParams: ParsedUrlQuery) => ParsedUrlQuery;
}): [React.ComponentType, () => Promise<void>];
